<?php

namespace App\Script;

use App\Model\Vendor;
use App\Script\Input;
use App\Script\Output;
use Exception;

/**
 * Main application class
 *
 * @author Phil Burton <phil@pgburton.com>
 */
class Console
{
    /**
     * Create symfony application and add commands
     *
     * @author Phil Burton <phil@pgburton.com>
     */
    public function __construct()
    {
        $this->init();
    }

    /**
     * Initalise
     *
     * @author Phil Burton <phil@pgburton.com>
     */
    protected function init()
    {
        // Define the root of the application
        define('APP_ROOT', realpath(dirname(__FILE__) . '/../../') . '/');

        // Set default tiemzone
        date_default_timezone_set('Europe/London');
    }

    /**
     * Run main application code
     *
     * @author Phil Burton <phil@pgburton.com>
     */
    public function exec()
    {
        $output = new Output;

        try {
            $input = new Input;
            // Get vendor data
            $vendors = Vendor::loadAll($input->getOption('f'));
            // Filter data
            $vendors->filterByInput($input);
            // Output data
            $output->printCollection($vendors);
        } catch (Exception $e) {
            $output->printException($e);
        }
    }
}
