<?php

namespace App\Script;

use App\Model\Collection;
use Exception;

/**
 * Handle output to CLI
 *
 * @author Phil Burton <phil@pgburton.com>
 */
class Output
{
    /**
     * Echo out the output data
     *
     * @author Phil Burton <phil@pgburton.com>
     * @param Collection $collection
     */
    public function printCollection(Collection $collection)
    {
        if (count($collection) === 0) {
            echo "No results found\n";
            return;
        }

        echo $collection->toString() . "\n";
    }

    /**
     * Output the exception message
     *
     * @author Phil Burton <phil@pgburton.com>
     * @param Exception $e
     */
    public function printException(Exception $e)
    {
        echo "An unexpected exception occured:\n" . $e->getMessage() . "\n";
    }
}
